{
Ŀ
                 Joe Forster/STA                 
                                                 
                   EXTUMOD.PAS                   
                                                 
                  UMOD extractor                 

}

uses
  DOS;

const
  fmReadOnly    = 0;
  fmWriteOnly   = 1;
  fmReadWrite   = 2;
  fmModeMask    = $0F;
  fmExclusive   = $20;
  fmShared      = $40;
  deOK          = 0;
  deFileNotFound= 2;
  dePathNotFound= 3;
  deAccessDenied= 5;
  deOutOfMemory = 8;
  MaxStrLen     = 255;
  MaxNameLen    = 80;
  BufferMax     = 61440;
  chDirSep      = '\';

type
  ExtFile       = record
    Orig        : file;
    LongName    : string;
  end;
  PExtFile      = ^ExtFile;
  TUMODMainHeader= record
    StartPos,
    EndPos      : Longint;
    Unknown     : array [0..7] of Byte;
  end;
  TUMODHeader   = record
    Name        : string;
    StartPos,
    Size        : Longint;
    Unknown     : array [0..3] of Byte;
  end;

var
  LongFileNames : Boolean;
  FileVersion,
  FileNum,
  FileNameLen,
  MaxFileNameLen: Byte;
  ReadAttr,
  BufferSize    : Word;
  IOError       : Integer;
  ReadTime,
  HeadPos,
  ReadSize,
  ReadPos       : Longint;
  ReadFile,
  WriteFile     : ExtFile;
  WritePath     : string;
  ReadBuffer    : array [0..BufferMax - 1] of Byte;
  DOSDate       : DateTime;
  UMODMainHeader: TUMODMainHeader;
  UMODHeader    : TUMODHeader;

function RightPos(C: Char; const S: string): Byte; assembler;
asm
    les di, S;
    mov al, es:[di];
    xor ah, ah;
    mov cx, ax;
    jcxz @1;
    add di, cx;
    mov al, C;
    std;
    repne scasb;
    jne @1;
    inc cx;
@1: mov ax, cx;
end;

function AddToPath(const P, S: string; C: Char): string;
var
  T             : string;
  W             : Word;
begin
  if P = '' then
  begin
    AddToPath := S;
  end
  else
  begin
    T := P;
    if Length(T) + Length(S) > 253 then T[0] := Chr(253 - Length(S));
    W := Length(T);
    if T[W] = '"' then Dec(W);
    if not (T[W] in [C, ':']) then T := T + C;
    AddToPath := T + S;
  end;
end;

function GetPath(const S: string; C: Char): string;
var
  B             : Word;
  T             : string;
begin
  B := RightPos(C, S);
  if (B = 0) and (Length(S) >= 2) and (S[2] = ':') then B := 2;
  if (B >= 2) and (S[B] = C) and (S[B - 1] <> ':') then Dec(B);
  T := Copy(S, 1, B);
  GetPath := T;
end;

procedure ExecLFN; assembler;
asm
    push ds;
    push ax;
    mov ax, Seg(InOutRes);
    mov ds, ax;
    cmp LongFileNames, False;
    pop ax;
    pop ds;
    jne @1;
    mov ax, $7100;
    stc;
    jmp @2;
@1: mov ah, $71;
    stc;
    int $21;
    jc @2;
    cmp ax, $7100;
    stc;
    je @2;
    clc;
@2:
end;

function InitLongNames: Boolean; assembler;
var
  S,
  T             : string;
asm
    push ds;
    push ss;
    pop ds;
    push ss;
    pop es;
    lea si, S;
    mov byte ptr [si], 0;
    lea di, T;
    xor cl, cl;
    mov ch, $80;
    mov al, $60;
    call ExecLFN;
    pop ds;
    mov bl, True;
    mov bh, MaxStrLen;
    jnc @1;
    cmp ax, $7100;
    jne @1;
    mov bl, False;
    mov bh, MaxNameLen;
@1: mov LongFileNames, bl;
    mov MaxFileNameLen, bh;
    mov al, bl;
end;

function LongParamStr(Index: Byte): string; assembler;
asm
    push ds;
    mov dl, Index;
    or dl, dl;
    je @12;
    xor dh, dh;
    mov ax, PrefixSeg;
    mov ds, ax;
    mov di, $0080;
    mov cl, [di];
    xor ch, ch;
    inc di;
    xor bx, bx;
    xor ah, ah;
@1: jcxz @3;
@2: mov al, [di];
    cmp al, '"';
    jne @7;
    xor ah, 1;
    inc di;
    dec cx;
    jmp @3;
@7: cmp al, ' ';
    ja @3;
    inc di;
    loop @2;
@3: mov si, di;
    jcxz @5;
@4: mov al, [di];
    cmp al, '"';
    jne @8;
    xor ah, 1;
@8: cmp al, ' ';
    ja @9;
    or ah, ah;
    je @5;
@9: inc di;
    loop @4;
@5: mov ax, di;
    sub ax, si;
    je @6;
    inc bx;
    dec dx;
    jnz @1;
@6: les di, @Result;
    mov bx, di;
    inc di;
    xor dl, dl;
    mov cx, ax;
    jcxz @12;
@11:lodsb;
    cmp al, '"';
    je @10;
    stosb;
    inc dl;
@10:loop @11;
@12:mov es:[bx], dl;
    pop ds;
end;

procedure LongMkDir(Name: string);
begin
  asm
    push ds;
    push ss
    pop ds;
    lea si, Name;
    mov bl, [si];
    xor bh, bh;
    inc si;
    mov byte ptr [si][bx], 0;
    mov dx, si;
    mov al, $39;
    call ExecLFN;
    jc @1;
    xor ax, ax;
@1: pop ds;
    mov InOutRes, ax;
  end;
end;

function LongOpenFile(Name: string; var F: ExtFile; Mode: Byte): Integer;
var
  B             : Byte;
  W             : Word;
  I             : Integer;
begin
  F.LongName := Name;
  B := 0;
  case Mode of
    fmReadOnly: B := fmShared;
    fmReadWrite, fmWriteOnly: B := fmExclusive;
  end;
  FileMode := Mode or B;
  asm
    mov W, 0;
    push ds;
    mov al, FileMode;
    xor ah, ah;
    push ax;
    push ss;
    pop ds;
    lea si, Name;
    mov bl, [si];
    xor bh, bh;
    inc si;
    mov byte ptr [si][bx], 0;
    xor di, di;
    mov dx, $01;
    mov bl, al;
    and bl, $0F;
    cmp bl, fmWriteOnly;
    jne @1;
    mov dx, $12;
@1: mov bl, al;
    mov al, $6C;
    xor cx, cx;
    call ExecLFN;
    pop bx;
    jnc @2;
    cmp ax, 5;
    jne @4;
    and bl, $0F;
    mov al, $6C;
    xor cx, cx;
    call ExecLFN;
    jnc @2;
@4: pop ds;
    mov W, ax;
    xor ax, ax;
    jmp @3;
@2: pop ds;
    les di, F;
    mov es:[di].ExtFile.Orig.FileRec.Mode, fmInOut;
    mov es:[di].ExtFile.Orig.FileRec.RecSize, 1;
@3: mov es:[di].ExtFile.Orig.FileRec.Handle, ax;
  end;
  LongOpenFile := W;
end;

procedure ExtClose(var F: ExtFile);
begin
  Close(F.Orig);
end;

function ExtFileSize(var F: ExtFile): Longint;
begin
  ExtFileSize := FileSize(F.Orig);
end;

procedure ExtSeek(var F: ExtFile; Pos: Longint);
begin
  Seek(F.Orig, Pos);
end;

procedure ExtGetFTime(var F: ExtFile; var Time: Longint);
begin
  GetFTime(F.Orig, Time);
end;

procedure ExtSetFTime(var F: ExtFile; Time: Longint);
begin
  SetFTime(F.Orig, Time);
end;

procedure ExtBlockRead(var F: ExtFile; var Buf; Count: Word);
begin
  BlockRead(F.Orig, Buf, Count);
end;

procedure ExtBlockWrite(var F: ExtFile; var Buf; Count: Word);
begin
  BlockWrite(F.Orig, Buf, Count);
end;

function MakeDirStructure(const Path: string): Integer;
var
  I             : Integer;

procedure MakeDir;
begin
  LongMkDir(Path);
  I := IOResult;
end;

begin
  MakeDir;
  if I = dePathNotFound then
  begin
    I := MakeDirStructure(GetPath(Path, chDirSep));
    if I = deOK then MakeDir;
  end;
  MakeDirStructure := I;
end;

procedure OpenWriteFile;
begin
  IOError := LongOpenFile(AddToPath(WritePath, UMODHeader.Name, chDirSep), WriteFile, fmWriteOnly);
end;

begin
  WriteLn('Unreal UMOD extractor by Joe Forster/STA');
  WriteLn;
  if ParamCount < 1 then
  begin
    WriteLn('This program extracts Unreal-style UMOD archives.');
    WriteLn;
    WriteLn('Usage: EXTUMOD <archive> [<destination-dir>]');
  end
  else
  begin
    LongFileNames := True;
    if InitLongNames then
    begin
      if LongOpenFile(LongParamStr(1), ReadFile, fmReadOnly) = 0 then
      begin
        ExtGetFTime(ReadFile, ReadTime);
        WritePath := LongParamStr(2);
        ExtSeek(ReadFile, ExtFileSize(ReadFile) - SizeOf(UMODMainHeader));
        ExtBlockRead(ReadFile, UMODMainHeader, SizeOf(UMODMainHeader));
        HeadPos := UMODMainHeader.StartPos;
        ExtSeek(ReadFile, HeadPos);
        ExtBlockRead(ReadFile, FileNum, SizeOf(FileNum));
        Inc(HeadPos, SizeOf(FileNum));
        ExtBlockRead(ReadFile, FileVersion, SizeOf(FileVersion));
        if FileVersion = 2 then Inc(HeadPos, SizeOf(FileVersion));
        ExtSeek(ReadFile, HeadPos);
        while FileNum > 0 do
        begin
          ExtBlockRead(ReadFile, FileNameLen, SizeOf(FileNameLen));
          ExtBlockRead(ReadFile, UMODHeader.Name[1], FileNameLen);
          ExtBlockRead(ReadFile, UMODHeader.StartPos, 3 * SizeOf(Longint));
          Inc(HeadPos, SizeOf(FileNameLen) + FileNameLen + (3 * SizeOf(Longint)));
          if FileNameLen > 0 then Dec(FileNameLen);
          UMODHeader.Name[0] := Chr(FileNameLen);
          ExtSeek(ReadFile, UMODHeader.StartPos);
          ReadSize := UMODHeader.Size;
          WriteLn('Extracting ', UMODHeader.Name);
          OpenWriteFile;
          if IOError = dePathNotFound then
          begin
            IOError := MakeDirStructure(GetPath(UMODHeader.Name, chDirSep));
            if IOError = deOK then
            begin
              OpenWriteFile;
              if IOError <> deOK then
                WriteLn('Can''t create ', GetPath(UMODHeader.Name, chDirSep));
            end
            else
            begin
              WriteLn('Can''t create ', AddToPath(WritePath, UMODHeader.Name, chDirSep));
            end;
          end;
          if IOError = deOK then
          begin
            ExtSeek(ReadFile, UMODHeader.StartPos);
            while ReadSize > 0 do
            begin
              if ReadSize > BufferMax then BufferSize := BufferMax else BufferSize := ReadSize;
              ExtBlockRead(ReadFile, ReadBuffer, BufferSize);
              ExtBlockWrite(WriteFile, ReadBuffer, BufferSize);
              Dec(ReadSize, BufferSize);
            end;
            ExtSetFTime(WriteFile, ReadTime);
            ExtClose(WriteFile);
          end;
          Dec(FileNum);
          if FileNum > 0 then ExtSeek(ReadFile, HeadPos);
        end;
        ExtClose(ReadFile);
      end
      else
      begin
        WriteLn('Can''t open ', LongParamStr(1));
      end;
    end
    else
    begin
      WriteLn('Long filenames are not available');
    end;
  end;
end.
